'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _command = require('./command');

var _command2 = _interopRequireDefault(_command);

var _mixins = require('./mixins');

var _mixins2 = _interopRequireDefault(_mixins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const api = superclass => {
  return class extends superclass {

    async init() {
      await super.init();
      let password = process.env.HEROKU_API_KEY;
      if (!password) {
        const netrc = require('netrc')();
        const host = netrc['api.heroku.com'];
        if (host) password = host.password;
      }
      if (!password) throw new Error('Not logged in');
      this.auth = { password };
    }
  };
};

exports.default = command => {
  let BaseCommand = _command2.default;
  if (command.needsApp) BaseCommand = _mixins2.default.app(BaseCommand);
  if (command.needsAuth) BaseCommand = api(BaseCommand);
  class NewCommand extends BaseCommand {
    async run() {
      await command.run(this);
    }
  }
  NewCommand.topic = command.topic;
  NewCommand.command = command.command;
  NewCommand.description = command.description;
  NewCommand.args = command.args;
  NewCommand.flags = command.flags;
  // TODO: variableArgs
  // NewCommand.variableArgs = command.variableArgs
  return NewCommand;
};