'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (Base, options = {}) {
  return class AppMixin extends Base {

    static get flags() {
      return this._flags.concat([APP_FLAG]);
    }
    static set flags(flags) {
      this._flags = flags;
    }

    async init() {
      await super.init();
      if (!this.app && options.required !== false) {
        throw new Error('No app specified');
      }
    }

    get app() {
      if (this._app) return this._app;
      if (typeof this.flags.app === 'string') this._app = this.flags.app;
      return this._app;
    }
  };
};

var _command = require('../command');

var _command2 = _interopRequireDefault(_command);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line
const APP_FLAG = {
  name: 'app',
  char: 'a',
  description: 'app to run command against',
  hasValue: true
};